# Stuffing
[![CI](https://github.com/guo-yong-zhi/Stuffing.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/guo-yong-zhi/Stuffing.jl/actions/workflows/ci.yml) [![CI-nightly](https://github.com/guo-yong-zhi/Stuffing.jl/actions/workflows/ci-nightly.yml/badge.svg)](https://github.com/guo-yong-zhi/Stuffing.jl/actions/workflows/ci-nightly.yml) [![codecov](https://codecov.io/gh/guo-yong-zhi/Stuffing.jl/branch/main/graph/badge.svg?token=43TOrL25V7)](https://codecov.io/gh/guo-yong-zhi/Stuffing.jl)  
It's a packing algorithm.  
The algorithm accepts **any shape of 2D raster masks** as inputs and is good at handling the packing problems of many gadgets. The implementation is based on Quadtree & gradient optimization. Also, it can be parallelized if you start `julia` with `julia --threads k`. This package is used by [WordCloud](https://github.com/guo-yong-zhi/WordCloud).  
Examples: [collision detection](./examples/collision.jl), [packing](./examples/packing.jl)  
Benchmark: [benchmark](https://github.com/guo-yong-zhi/WordCloud/blob/master/examples/benchmark.jl)   
See [WordCloud](https://github.com/guo-yong-zhi/WordCloud)  
***
▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▥▥▥▥▥▥▥▥▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▥▥▥▢▢▢▢▢▢▢▢▢▢▢▢▢▢▥▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▩▥▥▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▥▩▥▢▥▥▩▩▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▥▥▥▥▩▩▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▥▥▥▥▥▥▥▥▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▥▥▥▩▩▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▥▥▥▩▩▩▥▥▥▥▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▥▥▢▥▩▩▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▥▩▥▩▩▩▥▢▥▥▥▩▩▩▩▩▩▩
▩▩▩▩▩▩▥▥▢▢▥▩▩▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▥▩▥▩▩▩▥▢▥▥▥▥▩▩▩▩▩▩
▩▩▩▩▩▥▥▢▢▢▥▩▩▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▥▩▥▩▩▩▥▢▥▥▢▥▥▩▩▩▩▩
▩▩▩▩▥▥▥▥▥▥▥▩▩▥▩▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▥▥▥▥▥▥▥▥▩▩▩▥▢▥▥▢▢▥▥▩▩▩▩
▩▩▩▩▥▥▥▩▩▩▩▩▩▥▩▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▢▩▥▥▩▥▩▩▥▩▩▩▥▢▢▢▢▢▢▥▩▩▩▩
▩▩▩▥▥▥▥▩▩▩▩▩▩▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▢▥▥▥▩▥▩▩▥▥▥▥▥▥▥▥▥▥▥▥▥▩▩▩
▩▩▩▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▥▥▥▥▥▥▥▥▥▥▥▥▩▩▩▩▩▩▩▥▩▩▩
▩▩▩▥▥▢▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▥▩▩▩
▩▩▩▥▥▢▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▥▩▩▩
▩▩▩▥▥▥▥▩▩▩▩▩▩▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▥▩▩▩
▩▩▩▥▩▩▥▩▩▩▩▩▩▥▢▢▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▥▩▩▩
▩▩▩▥▩▩▥▩▩▩▩▩▩▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▥▩▩▩
▩▩▩▥▥▥▥▩▩▩▩▩▩▥▥▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▥▩▩▩
▩▩▩▥▢▢▥▩▩▩▩▩▩▥▥▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▥▩▩▩
▩▩▩▥▥▢▥▩▩▩▩▩▩▥▥▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▩▩▩▩▩▩▩▥▥▥▥▥▥▥▥▥▩▩▩
▩▩▩▩▥▢▥▩▩▩▩▩▩▥▥▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▥▢▢▥▩▩▩▩
▩▩▩▩▥▥▥▩▩▩▩▩▩▥▥▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▥▢▥▩▩▩▩▩
▩▩▩▩▩▥▥▥▥▥▥▥▥▥▩▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▥▥▥▩▩▩▩▩
▩▩▩▩▩▩▥▥▢▢▥▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▩▩▩▩▩▩▩▥▥▥▥▥▥▩▩▩▩▩▩
▩▩▩▩▩▩▩▥▥▢▥▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▩▩▩▩▩▩▩▩▩▩▥▩▥▥▥▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▥▥▥▩▩▩▩▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▥▥▩▩▥▥▥▥▥▥▥▥▥▥▥▥▥▥▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▥▥▥▥▩▩▩▩▥▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▥▩▩▥▢▥▩▥▢▢▥▥▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▩▩▥▥▥▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▥▩▩▥▢▥▩▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▥▩▩▩▥▥▥▥▢▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▥▥▥▥▥▥▥▥▥▥▥▥▩▩▩▥▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▥▥▥▥▥▥▥▥▥▥▥▥▥▥▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩
▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩▩
